#ifndef OPERATION_H
#define OPERATION_H

#define NUMBER_OPERATION(name) OP_##name##_INT, OP_##name##_FLOAT

typedef enum Operation {
    OP_NOTHING,
    NUMBER_OPERATION(PUSH),
    OP_PUSH_CONST_STRING,
    OP_PUSH_TRUE,
    OP_PUSH_FALSE,
    NUMBER_OPERATION(ADD),
    NUMBER_OPERATION(SUB),
    NUMBER_OPERATION(MUL),
    NUMBER_OPERATION(DIV),
    OP_MOD_INT,
    NUMBER_OPERATION(INVERT_SIGN),
    NUMBER_OPERATION(LESS),
    NUMBER_OPERATION(GREATER),
    NUMBER_OPERATION(EQUAL),
    OP_EQUAL_BOOL,
    OP_NOT,
    OP_AND,
    OP_OR,
    OP_BIT_NOT,
    OP_BIT_AND,
    OP_BIT_OR,
    OP_BIT_XOR,
    OP_LEFT_SHIFT,
    OP_RIGHT_SHIFT,
    NUMBER_OPERATION(PRINT),
    OP_PRINT_BOOL,
    OP_LINE,
    OP_GOTO,
    OP_IF_GOTO,
    OP_PEEK_FALSE_GOTO,
    OP_PEEK_TRUE_GOTO,
    OP_GOSUB,
    OP_RETURN,
    OP_RETURN_INT,
    OP_RETURN_BOOL,
    /*OP_ALLOCATE_ARRAY,
    OP_ARRAY_LENGTH,*/
    OP_RESERVE,
    OP_LOAD_INT,
    OP_STORE_INT,
    /*OP_REFERENCE_FROM_ARRAY,*/
} Operation;

#endif