#include <stdbool.h>

#include "DataType.h"

const char* dtGetName(DataType dt) {
    switch(dt) {
        case DT_INT: return "int";
        case DT_FLOAT: return "float";
        case DT_BOOL: return "bool";
        default: return "unknown";
    }
}

int dtGetSize(DataType dt) {
    switch(dt) {
        case DT_INT: return sizeof(int);
        case DT_FLOAT: return sizeof(float);
        case DT_BOOL: return sizeof(bool);
        default: return 0;
    }
}