#include "vm/Object.h"

const char* oGetName(ObjectType ot) {
    switch(ot) {
        case OT_INT: return "int";
        case OT_FLOAT: return "float";
        case OT_CONST_STRING: return "const string";
        case OT_NULL: return "null";
        case OT_BOOL: return "bool";
        case OT_VOID: return "void";
        case OT_ARRAY: return "array";
        case OT_REFERENCE: return "reference";
        default: return "unknown";
    }
}